<?php
# $RCSfile: tnt.php $ $Revision: 1.2 $ $Date: 2009/09/19 01:25:00 $

# TNT: Trigger Node Template (for use with php 4, 5)
# Version 1.0 for php5 (26-Apr-2009).
# Copyright Malcolm Dew-Jones 2009
# License
# TNT is released under the LGPL (Lesser GPL). More info on the LGPL
# is available at http://www.gnu.org/copyleft/lesser.html


$tnt_previous_error_reporting = error_reporting(E_ALL);

function tnt_load_template( $file 
                          , $cache_dir='' 
                          , $input_kludges=false
                          , $output_kludges=false
                          , $warnings=false
                          , $force=false
                          )
{

    $compile_required=true;

    if ($cache_dir != '')
    {
        $cached_file = "$cache_dir/".basename($file).".ph";
        if ( file_exists($cached_file) and !$force)
        {
            if ( filemtime($cached_file) > filemtime($file))
            {
                $compile_required=false;
            }

        } 

        if ($compile_required)       
        {
            $pid = getmypid();
            $temp_name = "$cached_file.$pid";
            if (!($fp = fopen($temp_name, "w"))) 
            {
                die("Could not open $temp_name");
            }
        }
    }

    if ($compile_required)
    {
        include_once("tnt-compiler.php");
        $tnt = new tnt_compiler();

        $tnt->set_kludge_nbsp_translate($input_kludges);
        $tnt->set_kludge_br_etc_tags_translate($input_kludges);

        $tnt->set_reencode_chardata($output_kludges);
        $tnt->set_remove_nonhtml_end_tags($output_kludges);

        $tnt->set_lint_warnings($warnings);

        ob_start();
        $name = $tnt->load_from_file($file);
        $php_code = ob_get_contents();
        ob_end_clean(); # no display
        ##echo $php_code;
    }

    if ($cache_dir == '')
    {
        eval( $php_code );
    }

    else
    {
        if ($compile_required)
        {
            $s1 =sprintf("%c?php",60);
            $s2 =sprintf("?%c",62);

            if (fwrite($fp,$s1,strlen($s1))  and
                fwrite($fp,$php_code,strlen($php_code)) and
                fwrite($fp,$s2,strlen($s2)) and
                fclose($fp)
               )
            {
                if (! rename($temp_name, $cached_file))
                    die( "error: rename($temp_name, $cached_file);");
            }
            else
            {
                die( "Error writing to $temp_name");
            }                
        }
        include($cached_file);
    }
}

# TESTING
if (!empty($argv))
if (!empty($argv[1]))
{
    $file = $argv[1];
    tnt_load_template( $file , '.' , true);
#    t6::start();
    list($name) = split('\.[a-zA-Z]*$',basename($file));
    $n=new $name;
    # will normally die due to callbacks, but leaves cached template
    $n->start();
}

error_reporting($tnt_previous_error_reporting);

?>